@JS()
library meethour;
// The above two lines are required,
// allows interoperability bettween dart and JS

import 'package:js/js.dart';

/// Extended `MeetHourExternalAPI' JS
///
/// Allows Dart code comunicate with the `MeetHourExternalAPI`
/// see https://github.com/v-empower/MeetHour-Web-MobileSDKs/tree/master/Web/Javascript/Generic-Javascript
@JS('meethour.MeetHourAPI')
class MeetHourAPI {
  /// Constructor
  external MeetHourAPI(String domain, String options);

  /// Generic handler Js for events
  external void on(String event, Function(dynamic message) callback);

  /// Interface to execute a command with `MeetHourExternalAPI`
  external void executeCommand(String command, List<String> arguments);

  /// Add an Event Listener for the `MeetHourExternalAPI`
  external void addEventListener(String eventName, Function callback);

  /// Remove Event Listener for the `MeetHourExternalAPI`
  external void removeEventListener(List<String> listener);

  /// remove instace
  external void dispose();
}
